import { MoveableProperties, MoveableInterface } from "moveable";
declare const VueMoveable: import("vue").DefineComponent<Partial<MoveableProperties>, {}, {}, {}, {
    getManager: () => import("moveable").MoveableManagerInterface<any, any>;
    getRect: () => import("moveable").RectInfo;
    getAble: <T extends import("moveable").Able<import("@daybrush/utils").IObject<any>, import("@daybrush/utils").IObject<any>>>(ableName: string) => T | undefined;
    isMoveableElement: (target: Element) => boolean;
    updateRect: (type?: "" | "Start" | "End" | undefined, isTarget?: boolean | undefined, isSetState?: boolean | undefined) => void;
    updateTarget: () => void;
    request: <RequestParam extends import("moveable").AbleRequesters[Name], Name extends string = string>(ableName: Name, params?: RequestParam | undefined, isInstant?: boolean | undefined) => import("moveable").Requester<RequestParam>;
    getMoveables: () => import("moveable").MoveableManagerInterface<{}, {}>[];
    getControlBoxElement: () => HTMLElement;
    getDragElement: () => HTMLElement | SVGElement | null | undefined;
    destroy: () => void;
    dragStart: (e: MouseEvent | TouchEvent, target?: EventTarget | null | undefined) => void;
    isInside: (clientX: number, clientY: number) => boolean;
    isDragging: (ableName?: string | undefined) => boolean;
    hitTest: (el: Element | import("moveable").HitRect) => number;
    setState: (state: any, callback?: (() => any) | undefined) => any;
    waitToChangeTarget: () => Promise<void>;
    forceUpdate: (callback?: (() => any) | undefined) => any;
    updateSelectors: () => void;
    getTargets: () => (HTMLElement | SVGElement)[];
    stopDrag: (type?: "target" | "control" | undefined) => void;
}, {}, {}, {
    dragStart: (e: import("moveable").OnDragStart) => void;
    render: (e: import("moveable").OnRender) => void;
    drag: (e: import("moveable").OnDrag) => void;
    dragEnd: (e: import("moveable").OnDragEnd) => void;
    pinchStart: (e: import("moveable").OnPinchStart) => void;
    pinch: (e: import("moveable").OnPinch) => void;
    pinchEnd: (e: import("moveable").OnPinchEnd) => void;
    dragGroupStart: (e: import("moveable").OnDragGroupStart) => void;
    dragGroup: (e: import("moveable").OnDragGroup) => void;
    dragGroupEnd: (e: import("moveable").OnDragGroupEnd) => void;
    pinchGroupStart: (e: import("moveable").OnPinchGroupStart) => void;
    pinchGroup: (e: import("moveable").OnPinchGroup) => void;
    pinchGroupEnd: (e: import("moveable").OnPinchGroupEnd) => void;
    scale: (e: import("moveable").OnScale) => void;
    snap: (e: import("moveable").OnSnap) => void;
    bound: (e: import("moveable").OnBound) => void;
    resizeStart: (e: import("moveable").OnResizeStart) => void;
    beforeResize: (e: import("moveable").OnBeforeResize) => void;
    resize: (e: import("moveable").OnResize) => void;
    resizeEnd: (e: import("moveable").OnResizeEnd) => void;
    resizeGroupStart: (e: import("moveable").OnResizeGroupStart) => void;
    beforeResizeGroup: (e: import("moveable").OnBeforeResizeGroup) => void;
    resizeGroup: (e: import("moveable").OnResizeGroup) => void;
    resizeGroupEnd: (e: import("moveable").OnResizeGroupEnd) => void;
    rotateStart: (e: import("moveable").OnRotateStart) => void;
    beforeRotate: (e: import("moveable").OnBeforeRotate) => void;
    rotate: (e: import("moveable").OnRotate) => void;
    rotateEnd: (e: import("moveable").OnRotateEnd) => void;
    rotateGroupStart: (e: import("moveable").OnRotateGroupStart) => void;
    beforeRotateGroup: (e: import("moveable").OnBeforeRotateGroup) => void;
    rotateGroup: (e: import("moveable").OnRotateGroup) => void;
    rotateGroupEnd: (e: import("moveable").OnRotateGroupEnd) => void;
    scaleStart: (e: import("moveable").OnScaleStart) => void;
    beforeScale: (e: import("moveable").OnBeforeScale) => void;
    scaleEnd: (e: import("moveable").OnScaleEnd) => void;
    scaleGroupStart: (e: import("moveable").OnScaleGroupStart) => void;
    beforeScaleGroup: (e: import("moveable").OnBeforeScaleGroup) => void;
    scaleGroup: (e: import("moveable").OnScaleGroup) => void;
    scaleGroupEnd: (e: import("moveable").OnScaleGroupEnd) => void;
    warpStart: (e: import("moveable").OnWarpStart) => void;
    warp: (e: import("moveable").OnWarp) => void;
    warpEnd: (e: import("moveable").OnWarpEnd) => void;
    click: (e: import("moveable").OnClick) => void;
    clickGroup: (e: import("moveable").OnClickGroup) => void;
    scroll: (e: import("moveable").OnScroll) => void;
    scrollGroup: (e: import("moveable").OnScrollGroup) => void;
    changeTargets: (e: import("moveable").OnChangeTargets) => void;
    clip: (e: import("moveable").OnClip) => void;
    round: (e: import("moveable").OnRound) => void;
    clipStart: (e: import("moveable").OnClipStart) => void;
    clipEnd: (e: import("moveable").OnClipEnd) => void;
    dragOriginStart: (e: import("moveable").OnDragOriginStart) => void;
    dragOrigin: (e: import("moveable").OnDragOrigin) => void;
    dragOriginEnd: (e: import("moveable").OnDragOriginEnd) => void;
    roundStart: (e: import("moveable").OnRoundStart) => void;
    roundEnd: (e: import("moveable").OnRoundEnd) => void;
    roundGroupStart: (e: import("moveable").OnRoundGroupStart) => void;
    roundGroup: (e: import("moveable").OnRoundGroup) => void;
    roundGroupEnd: (e: import("moveable").OnRoundGroupEnd) => void;
    beforeRenderStart: (e: import("moveable").OnBeforeRenderStart) => void;
    beforeRender: (e: import("moveable").OnBeforeRender) => void;
    beforeRenderEnd: (e: import("moveable").OnBeforeRenderEnd) => void;
    beforeRenderGroupStart: (e: import("moveable").OnBeforeRenderGroupStart) => void;
    beforeRenderGroup: (e: import("moveable").OnBeforeRenderGroup) => void;
    beforeRenderGroupEnd: (e: import("moveable").OnBeforeRenderGroupEnd) => void;
    renderStart: (e: import("moveable").OnRenderStart) => void;
    renderEnd: (e: import("moveable").OnRenderEnd) => void;
    renderGroupStart: (e: import("moveable").OnRenderGroupStart) => void;
    renderGroup: (e: import("moveable").OnRenderGroup) => void;
    renderGroupEnd: (e: import("moveable").OnRenderGroupEnd) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<Partial<MoveableProperties>> & {
    onDragStart?: ((e: import("moveable").OnDragStart) => any) | undefined;
    onDrag?: ((e: import("moveable").OnDrag) => any) | undefined;
    onDragEnd?: ((e: import("moveable").OnDragEnd) => any) | undefined;
    onDragGroupStart?: ((e: import("moveable").OnDragGroupStart) => any) | undefined;
    onDragGroup?: ((e: import("moveable").OnDragGroup) => any) | undefined;
    onDragGroupEnd?: ((e: import("moveable").OnDragGroupEnd) => any) | undefined;
    onDragOriginStart?: ((e: import("moveable").OnDragOriginStart) => any) | undefined;
    onDragOrigin?: ((e: import("moveable").OnDragOrigin) => any) | undefined;
    onDragOriginEnd?: ((e: import("moveable").OnDragOriginEnd) => any) | undefined;
    onRotateStart?: ((e: import("moveable").OnRotateStart) => any) | undefined;
    onBeforeRotate?: ((e: import("moveable").OnBeforeRotate) => any) | undefined;
    onRotate?: ((e: import("moveable").OnRotate) => any) | undefined;
    onRotateEnd?: ((e: import("moveable").OnRotateEnd) => any) | undefined;
    onRotateGroupStart?: ((e: import("moveable").OnRotateGroupStart) => any) | undefined;
    onBeforeRotateGroup?: ((e: import("moveable").OnBeforeRotateGroup) => any) | undefined;
    onRotateGroup?: ((e: import("moveable").OnRotateGroup) => any) | undefined;
    onRotateGroupEnd?: ((e: import("moveable").OnRotateGroupEnd) => any) | undefined;
    onResizeStart?: ((e: import("moveable").OnResizeStart) => any) | undefined;
    onBeforeResize?: ((e: import("moveable").OnBeforeResize) => any) | undefined;
    onResize?: ((e: import("moveable").OnResize) => any) | undefined;
    onResizeEnd?: ((e: import("moveable").OnResizeEnd) => any) | undefined;
    onResizeGroupStart?: ((e: import("moveable").OnResizeGroupStart) => any) | undefined;
    onBeforeResizeGroup?: ((e: import("moveable").OnBeforeResizeGroup) => any) | undefined;
    onResizeGroup?: ((e: import("moveable").OnResizeGroup) => any) | undefined;
    onResizeGroupEnd?: ((e: import("moveable").OnResizeGroupEnd) => any) | undefined;
    onScaleStart?: ((e: import("moveable").OnScaleStart) => any) | undefined;
    onBeforeScale?: ((e: import("moveable").OnBeforeScale) => any) | undefined;
    onScale?: ((e: import("moveable").OnScale) => any) | undefined;
    onScaleEnd?: ((e: import("moveable").OnScaleEnd) => any) | undefined;
    onScaleGroupStart?: ((e: import("moveable").OnScaleGroupStart) => any) | undefined;
    onBeforeScaleGroup?: ((e: import("moveable").OnBeforeScaleGroup) => any) | undefined;
    onScaleGroup?: ((e: import("moveable").OnScaleGroup) => any) | undefined;
    onScaleGroupEnd?: ((e: import("moveable").OnScaleGroupEnd) => any) | undefined;
    onWarpStart?: ((e: import("moveable").OnWarpStart) => any) | undefined;
    onWarp?: ((e: import("moveable").OnWarp) => any) | undefined;
    onWarpEnd?: ((e: import("moveable").OnWarpEnd) => any) | undefined;
    onPinchStart?: ((e: import("moveable").OnPinchStart) => any) | undefined;
    onPinch?: ((e: import("moveable").OnPinch) => any) | undefined;
    onPinchEnd?: ((e: import("moveable").OnPinchEnd) => any) | undefined;
    onPinchGroupStart?: ((e: import("moveable").OnPinchGroupStart) => any) | undefined;
    onPinchGroup?: ((e: import("moveable").OnPinchGroup) => any) | undefined;
    onPinchGroupEnd?: ((e: import("moveable").OnPinchGroupEnd) => any) | undefined;
    onSnap?: ((e: import("moveable").OnSnap) => any) | undefined;
    onBound?: ((e: import("moveable").OnBound) => any) | undefined;
    onScroll?: ((e: import("moveable").OnScroll) => any) | undefined;
    onScrollGroup?: ((e: import("moveable").OnScrollGroup) => any) | undefined;
    onClipStart?: ((e: import("moveable").OnClipStart) => any) | undefined;
    onClip?: ((e: import("moveable").OnClip) => any) | undefined;
    onClipEnd?: ((e: import("moveable").OnClipEnd) => any) | undefined;
    onRoundStart?: ((e: import("moveable").OnRoundStart) => any) | undefined;
    onRound?: ((e: import("moveable").OnRound) => any) | undefined;
    onRoundEnd?: ((e: import("moveable").OnRoundEnd) => any) | undefined;
    onRoundGroupStart?: ((e: import("moveable").OnRoundGroupStart) => any) | undefined;
    onRoundGroup?: ((e: import("moveable").OnRoundGroup) => any) | undefined;
    onRoundGroupEnd?: ((e: import("moveable").OnRoundGroupEnd) => any) | undefined;
    onBeforeRenderStart?: ((e: import("moveable").OnBeforeRenderStart) => any) | undefined;
    onBeforeRender?: ((e: import("moveable").OnBeforeRender) => any) | undefined;
    onBeforeRenderEnd?: ((e: import("moveable").OnBeforeRenderEnd) => any) | undefined;
    onBeforeRenderGroupStart?: ((e: import("moveable").OnBeforeRenderGroupStart) => any) | undefined;
    onBeforeRenderGroup?: ((e: import("moveable").OnBeforeRenderGroup) => any) | undefined;
    onBeforeRenderGroupEnd?: ((e: import("moveable").OnBeforeRenderGroupEnd) => any) | undefined;
    onClick?: ((e: import("moveable").OnClick) => any) | undefined;
    onClickGroup?: ((e: import("moveable").OnClickGroup) => any) | undefined;
    onRenderStart?: ((e: import("moveable").OnRenderStart) => any) | undefined;
    onRender?: ((e: import("moveable").OnRender) => any) | undefined;
    onRenderEnd?: ((e: import("moveable").OnRenderEnd) => any) | undefined;
    onRenderGroupStart?: ((e: import("moveable").OnRenderGroupStart) => any) | undefined;
    onRenderGroup?: ((e: import("moveable").OnRenderGroup) => any) | undefined;
    onRenderGroupEnd?: ((e: import("moveable").OnRenderGroupEnd) => any) | undefined;
    onChangeTargets?: ((e: import("moveable").OnChangeTargets) => any) | undefined;
}, {}, {}>;
interface VueMoveable extends Partial<MoveableProperties>, MoveableInterface {
}
export default VueMoveable;
