"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const VanillaMoveable = require("moveable");
const vue = require("vue");
const utils = require("@daybrush/utils");
const methods = {};
VanillaMoveable.METHODS.forEach((name) => {
  methods[name] = function(...args) {
    return this.$_moveable[name](...args);
  };
});
const watch = {};
VanillaMoveable.PROPERTIES.forEach((name) => {
  watch[name] = function(value) {
    this.$_moveable[name] = value;
  };
});
const VueMoveable = vue.defineComponent({
  name: "moveable",
  methods,
  props: VanillaMoveable.PROPERTIES,
  watch,
  mounted() {
    const options = {};
    const props = this.$props;
    VanillaMoveable.PROPERTIES.forEach((name) => {
      const value = props[name];
      if (!utils.isUndefined(value)) {
        options[name] = props[name];
      }
    });
    const refs = this.$refs;
    const moveableElement = refs.moveableElement;
    const moveable = new VanillaMoveable(moveableElement, {
      ...options,
      warpSelf: true
    });
    VanillaMoveable.EVENTS.forEach((name) => {
      moveable.on(name, (e) => {
        this.$emit(name, { ...e });
      });
    });
    this.$_moveable = moveable;
  },
  beforeUnmount() {
    this.$_moveable.destroy();
  }
});
const _sfc_main = VueMoveable;
const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _hoisted_1 = { ref: "moveableElement" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return vue.openBlock(), vue.createElementBlock("div", _hoisted_1, null, 512);
}
const Moveable = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
exports.VueMoveable = Moveable;
exports.default = Moveable;
Object.keys(VanillaMoveable).forEach((k) => {
  if (k !== "default" && !exports.hasOwnProperty(k))
    Object.defineProperty(exports, k, {
      enumerable: true,
      get: () => VanillaMoveable[k]
    });
});
